Overview | Package | Class | Tree | Deprecated | Index | Help
| J avolution v5.2 (J2SE 1.5+)
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## javolution.xml.stream
Class XMLStreamReaderImpl

    java.lang.Object
      javolution.xml.stream.XMLStreamReaderImpl

All Implemented Interfaces:
  Reusable, XMLStreamConstants, XMLStreamReader

    public final class XMLStreamReaderImpl

extends java.lang.Object
implements XMLStreamReader, Reusable

This class represents a `reusable` implementation of `XMLStreamWriter`.

Except for the types being used (`CharArray`/ `CharSequence` instead of `String`) the parsing behavior is about the same as for the standard `javax.xml.stream.XMLStreamReader` (although several times faster).

The `CharArray` instances returned by this reader supports fast primitive conversions as illustrated below:``

         // Creates reader for an input sream with unknown encoding.
         XMLStreamReaderImpl xmlReader = new XMLStreamReaderImpl().setInput(inputStream);

         // Parses.
         for (int e=xmlReader.next(); e != XMLStreamConstants.END_DOCUMENT; e = xmlReader.next()) {
             switch (e) { // Event.
                 case XMLStreamConstants.START_ELEMENT:
                 if (xmlReader.getLocalName().equals("Time")) {
                      // Reads primitive types (int) attributes directly.
                      int hour = xmlReader.getAttributeValue("hour").toInt();
                      int minute = xmlReader.getAttributeValue("minute").toInt();
                      int second = xmlReader.getAttributeValue("second").toInt();
                      ...
                 }
                 ...
                 break;
             }
         }

         // Closes reader, it is automatically reset() and can be reused!
         xmlReader.close();

This reader returns all contiguous character data in a single chunk (always coalescing). It is non-validating (DTD is returned unparsed). Although, users may define custom entities mapping using the `setEntities(java.util.Map)` method (e.g. after parsing/resolving external entities).

Version:
  4.0, September 4, 2006
Author:
  Jean-Marie Dautelle

Field Summary

Fields inherited from interface javolution.xml.stream.XMLStreamConstants
`ATTRIBUTE, CDATA, CHARACTERS, COMMENT, DTD, END_DOCUMENT, END_ELEMENT, ENTITY_DECLARATION, ENTITY_REFERENCE, NAMESPACE, NOTATION_DECLARATION, PROCESSING_INSTRUCTION, SPACE, START_DOCUMENT, START_ELEMENT`

Constructor Summary
`XMLStreamReaderImpl()` Default constructor.

Method Summary
`void` | `close()` Frees any resources associated with this Reader.
`int` | `getAttributeCount()` Returns the count of attributes on this START_ELEMENT, this method is only valid on a START_ELEMENT or ATTRIBUTE.
`CharArray` | `getAttributeLocalName(int index)` Returns the localName of the attribute at the provided index.
`CharArray` | `getAttributeNamespace(int index)` Returns the namespace of the attribute at the provided index
`CharArray` | `getAttributePrefix(int index)` Returns the prefix of this attribute at the provided index
`Attributes` | `getAttributes()` Returns the current attributes (SAX2-Like).
`CharArray` | `getAttributeType(int index)` Returns the XML type of the attribute at the provided index.
`CharArray` | `getAttributeValue(java.lang.CharSequence uri, java.lang.CharSequence localName)` Returns the normalized attribute value of the attribute with the namespace and localName.
`CharArray` | `getAttributeValue(int index)` Returns the value of the attribute at the index.
`CharArray` | `getCharacterEncodingScheme()` Returns the character encoding declared on the xml declaration.
`int` | `getDepth()` Returns the current depth of the element.
`CharArray` | `getElementText()` Reads the content of a text-only element, an exception is thrown if this is not a text-only element.
`java.lang.String` | `getEncoding()` Returns the input encoding if known or `null` if unknown.
`int` | `getEventType()` Returns an integer code that indicates the type of the event the cursor is pointing to.
`CharArray` | `getLocalName()` Returns the (local) name of the current event.
`Location` | `getLocation()` Return the current location of the processor.
`NamespaceContext` | `getNamespaceContext()` Returns a read only namespace context for the current position.
`int` | `getNamespaceCount()` Returns the count of namespaces declared on this START_ELEMENT or END_ELEMENT.
`CharArray` | `getNamespacePrefix(int index)` Returns the prefix for the namespace declared at the index.
`CharArray` | `getNamespaceURI()` If the current event is a START_ELEMENT or END_ELEMENT this method returns the URI of the current element (URI mapping to the prefix element/attribute has; or if no prefix `null`).
`CharArray` | `getNamespaceURI(java.lang.CharSequence prefix)` Returns the uri for the given prefix.
`CharArray` | `getNamespaceURI(int index)` Returns the URI for the namespace declared at the index.
`CharArray` | `getPIData()` Get the data section of a processing instruction.
`CharArray` | `getPITarget()` Returns the target of a processing instruction.
`CharArray` | `getPrefix()` Returns the prefix of the current event or null if the event does not have a prefix.
`java.lang.Object` | `getProperty(java.lang.String name)` Gets the value of a feature/property from the underlying implementation
`CharArray` | `getQName()` Returns the qualified name of the current event.
`CharArray` | `getText()` Returns the current value of the parse event as a string, this returns the string value of a CHARACTERS event, returns the value of a COMMENT, the replacement value for an ENTITY_REFERENCE, the string value of a CDATA section, the string value for a SPACE event, or the String value of the internal subset of the DTD.
`char[]` | `getTextCharacters()` Returns an array which contains the characters from this event.
`int` | `getTextCharacters(int sourceStart, char[] target, int targetStart, int length)` Gets the the text associated with a CHARACTERS, SPACE or CDATA event.
`int` | `getTextLength()` Returns the length of the sequence of characters for this Text event within the text character array.
`int` | `getTextStart()` Returns the offset into the text character array where the first character (of this text event) is stored.
`CharArray` | `getVersion()` Gets the xml version declared on the xml declaration.
`boolean` | `hasName()` Indicates if the current event has a name (is a START_ELEMENT or END_ELEMENT).
`boolean` | `hasNext()` Returns true if there are more parsing events and false if there are no more events.
`boolean` | `hasText()` Indicates if the current event has text.
`boolean` | `isAttributeSpecified(int index)` Indicates if this attribute was created by default.
`boolean` | `isCharacters()` Indicates if the cursor points to character data.
`boolean` | `isEndElement()` Indicates if the cursor points to an end tag.
`boolean` | `isStandalone()` Gets the standalone declaration from the xml declaration.
`boolean` | `isStartElement()` Indicates if the cursor points to a start tag.
`boolean` | `isWhiteSpace()` Indicates if the cursor points to character data that consists of all whitespace.
`int` | `next()` Gets next parsing event - contiguous character data is returned into a single chunk.
`int` | `nextTag()` Skips any white space (isWhiteSpace() returns true), COMMENT, or PROCESSING_INSTRUCTION, until a START_ELEMENT or END_ELEMENT is reached.
`void` | `require(int type, java.lang.CharSequence namespaceURI, java.lang.CharSequence localName)` Tests if the current event is of the given type and if the namespace and name match the current namespace and name of the current event.
`void` | `reset()` Resets the internal state of this object to its default values.
`void` | `setEntities(java.util.Map entities)` Defines a custom entities to replacement text mapping for this reader.
`void` | `setInput(java.io.InputStream in)` Sets the input stream source for this XML stream reader (encoding retrieved from XML prolog if any).
`void` | `setInput(java.io.InputStream in, java.lang.String encoding)` Sets the input stream source and encoding for this XML stream reader.
`void` | `setInput(java.io.Reader reader)` Sets the reader input source for this XML stream reader.
`boolean` | `standaloneSet()` Checks if standalone was set in the document.
`java.lang.String` | `toString()` Returns the textual representation of this reader current state.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### XMLStreamReaderImpl

    public XMLStreamReaderImpl()

  Default constructor.

Method Detail

### setInput

    public void setInput(java.io.InputStream in)
                  throws XMLStreamException

  Sets the input stream source for this XML stream reader (encoding retrieved from XML prolog if any).

  Parameters:
    `in` - the input source with unknown encoding.
  Throws:
    `XMLStreamException`

### setInput

    public void setInput(java.io.InputStream in,
                         java.lang.String encoding)
                  throws XMLStreamException

  Sets the input stream source and encoding for this XML stream reader.

  Parameters:
    `in` - the input source.
    `encoding` - the associated encoding.
  Throws:
    `XMLStreamException`

### setInput

    public void setInput(java.io.Reader reader)
                  throws XMLStreamException

  Sets the reader input source for this XML stream reader. This method reads the prolog (if any).

  Parameters:
    `reader` - the input source reader.
  Throws:
    `XMLStreamException`
  See Also:
    `UTF8StreamReader`, `UTF8ByteBufferReader`, `CharSequenceReader`

### getDepth

    public int getDepth()

  Returns the current depth of the element. Outside the root element, the depth is 0. The depth is incremented by 1 when a start tag is reached. The depth is decremented AFTER the end tag event was observed. `

       <!-- outside -->     0
       <root>               1
          sometext          1
          <foobar>          2
          </foobar>         2
       </root>              1
       <!-- outside -->     0

  `

  Returns:
    the nesting depth.

### getQName

    public CharArray getQName()

  Returns the qualified name of the current event.

  Returns:
    the qualified name.
  Throws:
    `java.lang.IllegalStateException` - if this not a START_ELEMENT or END_ELEMENT.

### getAttributes

    public Attributes getAttributes()

  Returns the current attributes (SAX2-Like).

  Returns:
    returns the number of attributes.
  Throws:
    `java.lang.IllegalStateException` - if not a START_ELEMENT.

### setEntities

    public void setEntities(java.util.Map entities)

  Defines a custom entities to replacement text mapping for this reader. For example:`

           FastMap<String, String> HTML_ENTITIES = new FastMap<String, String>();
           HTML_ENTITIES.put("nbsp", " ");
           HTML_ENTITIES.put("copy", "©");
           HTML_ENTITIES.put("eacute", "é");
           ...
           XMLStreamReaderImpl reader = new XMLStreamReaderImpl();
           reader.setEntities(HTML_ENTITIES);

  ` The entities mapping may be changed dynamically (e.g. after reading the DTD and all external entities references are resolved).

  Parameters:
    `entities` - the entities to replacement texts mapping (both must be `CharSequence` instances).

### toString

    public java.lang.String toString()

  Returns the textual representation of this reader current state.

  Overrides:
    `toString` in class `java.lang.Object`
  Returns:
    the textual representation of the current state.

### next

    public int next()
             throws XMLStreamException

  Description copied from interface: `XMLStreamReader`
  Gets next parsing event - contiguous character data is returned into a single chunk. By default entity references must be expanded and reported transparently to the application. An exception will be thrown if an entity reference cannot be expanded. If element content is empty (i.e. content is "") then no CHARACTERS event will be reported.

  Given the following XML:
  <foo><!--description-->content text<![CDATA[<greeting>Hello</greeting>]]>other content</foo>
  The behavior of calling next() when being on foo will be:
  1- the comment (COMMENT)
  2- then the characters section (CHARACTERS)
  3- then the CDATA section (another CHARACTERS)
  4- then the next characters section (another CHARACTERS)
  5- then the END_ELEMENT

  NOTE: empty element (such as <tag/>) will be reported with two separate events: START_ELEMENT, END_ELEMENT - This preserves parsing equivalency of empty element to <tag></tag>. This method will throw an IllegalStateException if it is called after hasNext() returns false.

  Specified by:
    `next` in interface `XMLStreamReader`
  Returns:
    the integer code corresponding to the current parse event
  Throws:
    `XMLStreamException` - if there is an error processing the underlying XML source

### reset

    public void reset()

  Description copied from interface: `Reusable`
  Resets the internal state of this object to its default values.

  Specified by:
    `reset` in interface `Reusable`

### require

    public void require(int type,
                        java.lang.CharSequence namespaceURI,
                        java.lang.CharSequence localName)
                 throws XMLStreamException

  Description copied from interface: `XMLStreamReader`
  Tests if the current event is of the given type and if the namespace and name match the current namespace and name of the current event. If the namespaceURI is null it is not checked for equality, if the localName is null it is not checked for equality.

  Specified by:
    `require` in interface `XMLStreamReader`
  Parameters:
    `type` - the event type.
    `namespaceURI` - the uri of the event, may be null.
    `localName` - the localName of the event, may be null.
  Throws:
    `XMLStreamException` - if the required values are not matched.

### getElementText

    public CharArray getElementText()
                             throws XMLStreamException

  Description copied from interface: `XMLStreamReader`
  Reads the content of a text-only element, an exception is thrown if this is not a text-only element. Regardless of the value of javax.xml.stream.isCoalescing this method always returns coalesced content.
  Precondition: the current event is START_ELEMENT.
  Postcondition: the current event is the corresponding END_ELEMENT.
  The method does the following (implementations are free to optimized but must do equivalent processing):

       if (getEventType() != XMLStreamConstants.START_ELEMENT) {
              throw new XMLStreamException(
                              "parser must be on START_ELEMENT to read next text", getLocation());
       }
       int eventType = next();
       StringBuffer content = new StringBuffer();
       while (eventType != XMLStreamConstants.END_ELEMENT) {
              if (eventType == XMLStreamConstants.CHARACTERS
                              || eventType == XMLStreamConstants.CDATA
                              || eventType == XMLStreamConstants.SPACE
                              || eventType == XMLStreamConstants.ENTITY_REFERENCE) {
                      buf.append(getText());
              } else if (eventType == XMLStreamConstants.PROCESSING_INSTRUCTION
                              || eventType == XMLStreamConstants.COMMENT) {
                      // skipping
              } else if (eventType == XMLStreamConstants.END_DOCUMENT) {
                      throw new XMLStreamException(
                                      "unexpected end of document when reading element text content",
                                      this);
              } else if (eventType == XMLStreamConstants.START_ELEMENT) {
                      throw new XMLStreamException(
                                      "element text content may not contain START_ELEMENT",
                                      getLocation());
              } else {
                      throw new XMLStreamException("Unexpected event type " + eventType,
                                      getLocation());
              }
              eventType = next();
       }
       return buf.toString();

  Specified by:
    `getElementText` in interface `XMLStreamReader`
  Throws:
    `XMLStreamException` - if the current event is not a START_ELEMENT or if a non text element is encountered.

### getProperty

    public java.lang.Object getProperty(java.lang.String name)
                                 throws java.lang.IllegalArgumentException

  Description copied from interface: `XMLStreamReader`
  Gets the value of a feature/property from the underlying implementation

  Specified by:
    `getProperty` in interface `XMLStreamReader`
  Parameters:
    `name` - the name of the property.
  Returns:
    the value of the property.
  Throws:
    `java.lang.IllegalArgumentException`

### close

    public void close()
               throws XMLStreamException

  Description copied from interface: `XMLStreamReader`
  Frees any resources associated with this Reader. This method does not close the underlying input source.

  Specified by:
    `close` in interface `XMLStreamReader`
  Throws:
    `XMLStreamException` - if there are errors freeing associated resources

### getAttributeCount

    public int getAttributeCount()

  Description copied from interface: `XMLStreamReader`
  Returns the count of attributes on this START_ELEMENT, this method is only valid on a START_ELEMENT or ATTRIBUTE. This count excludes namespace definitions. Attribute indices are zero-based.

  Specified by:
    `getAttributeCount` in interface `XMLStreamReader`
  Returns:
    returns the number of attributes.

### getAttributeLocalName

    public CharArray getAttributeLocalName(int index)

  Description copied from interface: `XMLStreamReader`
  Returns the localName of the attribute at the provided index.

  Specified by:
    `getAttributeLocalName` in interface `XMLStreamReader`
  Parameters:
    `index` - the position of the attribute.
  Returns:
    the localName of the attribute.

### getAttributeNamespace

    public CharArray getAttributeNamespace(int index)

  Description copied from interface: `XMLStreamReader`
  Returns the namespace of the attribute at the provided index

  Specified by:
    `getAttributeNamespace` in interface `XMLStreamReader`
  Parameters:
    `index` - the position of the attribute.
  Returns:
    the namespace URI or `null` if no prefix.

### getAttributePrefix

    public CharArray getAttributePrefix(int index)

  Description copied from interface: `XMLStreamReader`
  Returns the prefix of this attribute at the provided index

  Specified by:
    `getAttributePrefix` in interface `XMLStreamReader`
  Parameters:
    `index` - the position of the attribute.
  Returns:
    the prefix of the attribute or `null` if no prefix.

### getAttributeType

    public CharArray getAttributeType(int index)

  Description copied from interface: `XMLStreamReader`
  Returns the XML type of the attribute at the provided index.

  Specified by:
    `getAttributeType` in interface `XMLStreamReader`
  Parameters:
    `index` - the position of the attribute
  Returns:
    the XML type of the attribute.

### getAttributeValue

    public CharArray getAttributeValue(java.lang.CharSequence uri,
                                       java.lang.CharSequence localName)

  Description copied from interface: `XMLStreamReader`
  Returns the normalized attribute value of the attribute with the namespace and localName.

  Specified by:
    `getAttributeValue` in interface `XMLStreamReader`
  Parameters:
    `uri` - the namespace of the attribute or `null`.
    `localName` - the local name of the attribute.
  Returns:
    returns the value of the attribute or `null`.

### getAttributeValue

    public CharArray getAttributeValue(int index)

  Description copied from interface: `XMLStreamReader`
  Returns the value of the attribute at the index.

  Specified by:
    `getAttributeValue` in interface `XMLStreamReader`
  Parameters:
    `index` - the position of the attribute.
  Returns:
    the attribute value.

### getCharacterEncodingScheme

    public CharArray getCharacterEncodingScheme()

  Description copied from interface: `XMLStreamReader`
  Returns the character encoding declared on the xml declaration.

  Specified by:
    `getCharacterEncodingScheme` in interface `XMLStreamReader`
  Returns:
    the encoding declared in the document or `null`

### getEncoding

    public java.lang.String getEncoding()

  Description copied from interface: `XMLStreamReader`
  Returns the input encoding if known or `null` if unknown.

  Specified by:
    `getEncoding` in interface `XMLStreamReader`
  Returns:
    the encoding of this instance or null.

### getEventType

    public int getEventType()

  Description copied from interface: `XMLStreamReader`
  Returns an integer code that indicates the type of the event the cursor is pointing to.

  Specified by:
    `getEventType` in interface `XMLStreamReader`
  Returns:
    the event type.

### getLocalName

    public CharArray getLocalName()

  Description copied from interface: `XMLStreamReader`
  Returns the (local) name of the current event. For START_ELEMENT or END_ELEMENT returns the (local) name of the current element. For ENTITY_REFERENCE it returns entity name. The current event must be START_ELEMENT or END_ELEMENT, or ENTITY_REFERENCE.

  Specified by:
    `getLocalName` in interface `XMLStreamReader`
  Returns:
    the localName.

### getLocation

    public Location getLocation()

  Description copied from interface: `XMLStreamReader`
  Return the current location of the processor. If the Location is unknown the processor should return an implementation of Location that returns -1 for the location and null for the publicId and systemId. The location information is only valid until next() is called.

  Specified by:
    `getLocation` in interface `XMLStreamReader`
  Returns:
    the current location.

### getNamespaceCount

    public int getNamespaceCount()

  Description copied from interface: `XMLStreamReader`
  Returns the count of namespaces declared on this START_ELEMENT or END_ELEMENT. This method is only valid on a START_ELEMENT, END_ELEMENT or NAMESPACE. On an END_ELEMENT the count is of the namespaces that are about to go out of scope. This is the equivalent of the information reported by SAX callback for an end element event.

  Specified by:
    `getNamespaceCount` in interface `XMLStreamReader`
  Returns:
    returns the number of namespace declarations on this specific element.

### getNamespacePrefix

    public CharArray getNamespacePrefix(int index)

  Description copied from interface: `XMLStreamReader`
  Returns the prefix for the namespace declared at the index.

  Specified by:
    `getNamespacePrefix` in interface `XMLStreamReader`
  Parameters:
    `index` - the position of the namespace declaration.
  Returns:
    returns the namespace prefix or `null` if no prefix.

### getNamespaceURI

    public CharArray getNamespaceURI(java.lang.CharSequence prefix)

  Description copied from interface: `XMLStreamReader`
  Returns the uri for the given prefix. The uri returned depends on the current state of the processor.

  NOTE:The 'xml' prefix is bound as defined in Namespaces in XML specification to "http://www.w3.org/XML/1998/namespace".

  NOTE: The 'xmlns' prefix must be resolved to following namespace http://www.w3.org/2000/xmlns/

  Specified by:
    `getNamespaceURI` in interface `XMLStreamReader`
  Parameters:
    `prefix` - the prefix to lookup.
  Returns:
    the uri bound to the given prefix or `null` if it is not bound

### getNamespaceURI

    public CharArray getNamespaceURI(int index)

  Description copied from interface: `XMLStreamReader`
  Returns the URI for the namespace declared at the index.

  Specified by:
    `getNamespaceURI` in interface `XMLStreamReader`
  Parameters:
    `index` - the position of the namespace declaration.
  Returns:
    returns the namespace uri or `null` if no prefix.

### getNamespaceContext

    public NamespaceContext getNamespaceContext()

  Description copied from interface: `XMLStreamReader`
  Returns a read only namespace context for the current position.

  Specified by:
    `getNamespaceContext` in interface `XMLStreamReader`
  Returns:
    return a namespace context

### getNamespaceURI

    public CharArray getNamespaceURI()

  Description copied from interface: `XMLStreamReader`
  If the current event is a START_ELEMENT or END_ELEMENT this method returns the URI of the current element (URI mapping to the prefix element/attribute has; or if no prefix `null`).

  Specified by:
    `getNamespaceURI` in interface `XMLStreamReader`
  Returns:
    the URI bound to this elements prefix or `null`.

### getPrefix

    public CharArray getPrefix()

  Description copied from interface: `XMLStreamReader`
  Returns the prefix of the current event or null if the event does not have a prefix.

  Specified by:
    `getPrefix` in interface `XMLStreamReader`
  Returns:
    the prefix or `null`

### getPIData

    public CharArray getPIData()

  Description copied from interface: `XMLStreamReader`
  Get the data section of a processing instruction.

  Specified by:
    `getPIData` in interface `XMLStreamReader`
  Returns:
    the data (if processing instruction has any) or `null` if the processing instruction only has target.

### getPITarget

    public CharArray getPITarget()

  Description copied from interface: `XMLStreamReader`
  Returns the target of a processing instruction.

  Specified by:
    `getPITarget` in interface `XMLStreamReader`
  Returns:
    the target.

### getText

    public CharArray getText()

  Description copied from interface: `XMLStreamReader`
  Returns the current value of the parse event as a string, this returns the string value of a CHARACTERS event, returns the value of a COMMENT, the replacement value for an ENTITY_REFERENCE, the string value of a CDATA section, the string value for a SPACE event, or the String value of the internal subset of the DTD. If an ENTITY_REFERENCE has been resolved, any character data will be reported as CHARACTERS events.

  Specified by:
    `getText` in interface `XMLStreamReader`
  Returns:
    the current text or `null`

### getTextCharacters

    public char[] getTextCharacters()

  Description copied from interface: `XMLStreamReader`
  Returns an array which contains the characters from this event. This array should be treated as read-only and transient. I.e. the array will contain the text characters until the XMLStreamReader moves on to the next event. Attempts to hold onto the character array beyond that time or modify the contents of the array are breaches of the contract for this interface.

  Specified by:
    `getTextCharacters` in interface `XMLStreamReader`
  Returns:
    the current text or an empty array.

### getTextCharacters

    public int getTextCharacters(int sourceStart,
                                 char[] target,
                                 int targetStart,
                                 int length)
                          throws XMLStreamException

  Description copied from interface: `XMLStreamReader`
  Gets the the text associated with a CHARACTERS, SPACE or CDATA event. Text starting a "sourceStart" is copied into "target" starting at "targetStart". Up to "length" characters are copied. The number of characters actually copied is returned. The "sourceStart" argument must be greater or equal to 0 and less than or equal to the number of characters associated with the event. Usually, one requests text starting at a "sourceStart" of 0. If the number of characters actually copied is less than the "length", then there is no more text. Otherwise, subsequent calls need to be made until all text has been retrieved. For example: `int length = 1024; char[] myBuffer = new char[ length ]; for ( int sourceStart = 0 ; ; sourceStart += length ) { int nCopied = stream.getTextCharacters( sourceStart, myBuffer, 0, length ); if (nCopied < length) break; }` XMLStreamException may be thrown if there are any XML errors in the underlying source. The "targetStart" argument must be greater than or equal to 0 and less than the length of "target", Length must be greater than 0 and "targetStart + length" must be less than or equal to length of "target".

  Specified by:
    `getTextCharacters` in interface `XMLStreamReader`
  Parameters:
    `sourceStart` - the index of te first character in the source array to copy
    `target` - the destination array
    `targetStart` - the start offset in the target array
    `length` - the number of characters to copy
  Returns:
    the number of characters actually copied
  Throws:
    `XMLStreamException` - if the XML source is not well-formed.

### getTextLength

    public int getTextLength()

  Description copied from interface: `XMLStreamReader`
  Returns the length of the sequence of characters for this Text event within the text character array.

  Specified by:
    `getTextLength` in interface `XMLStreamReader`

### getTextStart

    public int getTextStart()

  Description copied from interface: `XMLStreamReader`
  Returns the offset into the text character array where the first character (of this text event) is stored.

  Specified by:
    `getTextStart` in interface `XMLStreamReader`

### getVersion

    public CharArray getVersion()

  Description copied from interface: `XMLStreamReader`
  Gets the xml version declared on the xml declaration.

  Specified by:
    `getVersion` in interface `XMLStreamReader`
  Returns:
    the XML version or `null`

### isStandalone

    public boolean isStandalone()

  Description copied from interface: `XMLStreamReader`
  Gets the standalone declaration from the xml declaration.

  Specified by:
    `isStandalone` in interface `XMLStreamReader`
  Returns:
    `true` if this is standalone; `false` otherwise.

### standaloneSet

    public boolean standaloneSet()

  Description copied from interface: `XMLStreamReader`
  Checks if standalone was set in the document.

  Specified by:
    `standaloneSet` in interface `XMLStreamReader`
  Returns:
    `true` if standalone was set; `false` otherwise.

### hasName

    public boolean hasName()

  Description copied from interface: `XMLStreamReader`
  Indicates if the current event has a name (is a START_ELEMENT or END_ELEMENT).

  Specified by:
    `hasName` in interface `XMLStreamReader`
  Returns:
    `true` if the current event has a name; `false` otherwise.

### hasNext

    public boolean hasNext()
                    throws XMLStreamException

  Description copied from interface: `XMLStreamReader`
  Returns true if there are more parsing events and false if there are no more events. This method will return false if the current state of the XMLStreamReader is END_DOCUMENT.

  Specified by:
    `hasNext` in interface `XMLStreamReader`
  Returns:
    true if there are more events, false otherwise.
  Throws:
    `XMLStreamException` - if there is a fatal error detecting the next state.

### hasText

    public boolean hasText()

  Description copied from interface: `XMLStreamReader`
  Indicates if the current event has text. The following events have text: CHARACTERS, DTD ,ENTITY_REFERENCE, COMMENT, SPACE.

  Specified by:
    `hasText` in interface `XMLStreamReader`
  Returns:
    `true` if the current event as text; `false` otherwise.

### isAttributeSpecified

    public boolean isAttributeSpecified(int index)

  Description copied from interface: `XMLStreamReader`
  Indicates if this attribute was created by default.

  Specified by:
    `isAttributeSpecified` in interface `XMLStreamReader`
  Parameters:
    `index` - the position of the attribute.
  Returns:
    `true` if this is a default attribute; `false` otherwise.

### isCharacters

    public boolean isCharacters()

  Description copied from interface: `XMLStreamReader`
  Indicates if the cursor points to character data.

  Specified by:
    `isCharacters` in interface `XMLStreamReader`
  Returns:
    `true` if the cursor points to character data; `false` otherwise.

### isEndElement

    public boolean isEndElement()

  Description copied from interface: `XMLStreamReader`
  Indicates if the cursor points to an end tag.

  Specified by:
    `isEndElement` in interface `XMLStreamReader`
  Returns:
    `true` if the cursor points to a end tag; `false` otherwise.

### isStartElement

    public boolean isStartElement()

  Description copied from interface: `XMLStreamReader`
  Indicates if the cursor points to a start tag.

  Specified by:
    `isStartElement` in interface `XMLStreamReader`
  Returns:
    `true` if the cursor points to a start tag; `false` otherwise.

### isWhiteSpace

    public boolean isWhiteSpace()

  Description copied from interface: `XMLStreamReader`
  Indicates if the cursor points to character data that consists of all whitespace.

  Specified by:
    `isWhiteSpace` in interface `XMLStreamReader`
  Returns:
    `true` if the cursor points to whitespaces; `false` otherwise.

### nextTag

    public int nextTag()
                throws XMLStreamException

  Description copied from interface: `XMLStreamReader`
  Skips any white space (isWhiteSpace() returns true), COMMENT, or PROCESSING_INSTRUCTION, until a START_ELEMENT or END_ELEMENT is reached. If other than white space characters, COMMENT, PROCESSING_INSTRUCTION, START_ELEMENT, END_ELEMENT are encountered, an exception is thrown. This method should be used when processing element-only content seperated by white space.
  Precondition: none
  Postcondition: the current event is START_ELEMENT or END_ELEMENT and cursor may have moved over any whitespace event.
  Essentially it does the following (implementations are free to optimized but must do equivalent processing):

         int eventType = next();
         while((eventType == XMLStreamConstants.CHARACTERS && isWhiteSpace()) // skip whitespace
         || (eventType == XMLStreamConstants.CDATA && isWhiteSpace())
         // skip whitespace
         || eventType == XMLStreamConstants.SPACE
         || eventType == XMLStreamConstants.PROCESSING_INSTRUCTION
         || eventType == XMLStreamConstants.COMMENT
         ) {
         eventType = next();
         }
         if (eventType != XMLStreamConstants.START_ELEMENT && eventType != XMLStreamConstants.END_ELEMENT) {
         throw new String XMLStreamException("expected start or end tag", getLocation());
         }
         return eventType;

  Specified by:
    `nextTag` in interface `XMLStreamReader`
  Returns:
    the event type of the element read (START_ELEMENT or END_ELEMENT)
  Throws:
    `XMLStreamException` - if the current event is not white space, PROCESSING_INSTRUCTION, START_ELEMENT or END_ELEMENT

Overview | Package | Class | Tree | Deprecated | Index | Help
| J avolution v5.2 (J2SE 1.5+)
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2005 - 2007 Javolution.